/*
 * Copyright (C) 1995 Phil Servita (meister@ftp.com)
 */	  
/*
 * otp dialog boxes
 */	  

#include <windows.h>
#include <toolhelp.h>
#include <stdio.h>
#include <string.h>
#include "otpdlg.h"

void BoxAndBeep (HWND, char *, char *, int);
extern char *ComputePassPhrase (char *, char *);
extern int CopyPassphraseToClipBoard (char *pass);
extern char *GetClipboardContents (void);
extern void SetHashAlg (char *);
extern void SetClipAppendStr (char *str);
extern void DisplayAsWords (void);
extern void DisplayAsHex (void);

void DecrementCount (HWND);

static int autodecrement = 0;

extern FARPROC  lpfnAboutDlgProc;
extern HANDLE   hAboutDlgInstance;

/* 
 * dialog for my aboutbox
 */	 

BOOL FAR PASCAL 
AboutDlgProc (HWND hDlg, WORD message, WORD wParam, LONG lParam)
{
    switch (message)
    {       case WM_INITDIALOG:
		 MessageBeep (0);
                 return FALSE;

            case WM_COMMAND:
                 switch (wParam)
                 {       case IDOK:
                         case IDCANCEL:
                              EndDialog (hDlg, 0);
                              return TRUE;
                 }
                 break;
    }
    return FALSE;
}


/* 
 * main dialog; *everything* gets done here
 */	 

BOOL FAR PASCAL 
WinOTPDlgProc (HWND hDlg, WORD message, WORD wParam, LONG lParam)
{   static char params [128];
    static char passwd [128];
    char *passphrase, *tmp;
    HWND handle;

    switch (message)
    {       case WM_INITDIALOG:
                 SetHashAlg ("MD5");
		 SetClipAppendStr ("");
                 CheckRadioButton (hDlg, WOTP_DISPWORDS, 
                                   WOTP_DISPHEX, WOTP_DISPWORDS);
                 CheckRadioButton (hDlg, WOTP_MD4, 
                                   WOTP_SHA1, WOTP_MD5);
                 CheckRadioButton (hDlg, WOTP_CLIPADDCR, 
                                   WOTP_CLIPADDNONE, WOTP_CLIPADDCR);
                 return FALSE;

            case WM_COMMAND:
                 switch (wParam)
                 {       case WOTP_EXIT:
			 case IDCANCEL:
                              EndDialog (hDlg, 0);
                              return TRUE;

                         case WOTP_DISPWORDS:
                              CheckRadioButton (hDlg, WOTP_DISPWORDS, 
                                                WOTP_DISPHEX, WOTP_DISPWORDS);
                              DisplayAsWords ();
                              return TRUE;

                         case WOTP_DISPHEX:
                              CheckRadioButton (hDlg, WOTP_DISPWORDS, 
                                                WOTP_DISPHEX, WOTP_DISPHEX);
                              DisplayAsHex ();
                              return TRUE;
			      
                         case WOTP_MD4:
                              CheckRadioButton (hDlg, WOTP_MD4, 
                                                WOTP_SHA1, WOTP_MD4);
                              SetHashAlg ("MD4");
                              return TRUE;

                         case WOTP_MD5:
                              CheckRadioButton (hDlg, WOTP_MD4, 
                                                WOTP_SHA1, WOTP_MD5);
                              SetHashAlg ("MD5");
                              return TRUE;			      

                         case WOTP_SHA1:
                              CheckRadioButton (hDlg, WOTP_MD4, 
                                                WOTP_SHA1, WOTP_SHA1);
                              SetHashAlg ("SHA1");
                              return TRUE;			      
			      
                         case WOTP_COMPUTE:
                              handle = GetDlgItem (hDlg, WOTP_PARAMS);
                              GetWindowText (handle, (LPSTR) params,
                                             sizeof (params) - 1);
                              handle = GetDlgItem (hDlg, WOTP_SECRET);
                              GetWindowText (handle, (LPSTR) passwd,
                                             sizeof (params) - 1);
                              SetWindowText (handle, "");     
                              passphrase = ComputePassPhrase (params, passwd);
                              if (passphrase)
                              {   handle = GetDlgItem (hDlg, WOTP_PHRASE);
                                  SetWindowText (handle, passphrase);
                                  if (autodecrement) 
                                      DecrementCount (hDlg);
                              }
                              return TRUE;

                         case WOTP_CLIPBOARD:
                              handle = GetDlgItem (hDlg, WOTP_PHRASE);
                              GetWindowText (handle, (LPSTR) passwd,
                                             sizeof (passwd) - 1);
                              CopyPassphraseToClipBoard (passwd);
                              return TRUE;
			      
                         case WOTP_GETCLIPBOARD:			      
                              tmp = GetClipboardContents ();
                              if (!tmp)
                                  return TRUE;
                              handle = GetDlgItem (hDlg, WOTP_PARAMS);
                              SetWindowText (handle, (LPSTR) tmp);
                              return TRUE;
                              
                         case WOTP_INFO:
                              (void) DialogBox (hAboutDlgInstance, 
                                                "AboutDlg", hDlg, 
                                                lpfnAboutDlgProc);
                              return TRUE;
			      
                         case WOTP_CLIPADDNONE:
                              CheckRadioButton (hDlg, WOTP_CLIPADDCR, 
                                                WOTP_CLIPADDNONE,
                                                WOTP_CLIPADDNONE);
                              SetClipAppendStr ("");
                              return TRUE;

                         case WOTP_CLIPADDCR:
                              CheckRadioButton (hDlg, WOTP_CLIPADDCR, 
                                                WOTP_CLIPADDNONE,
                                                WOTP_CLIPADDCR);
                              SetClipAppendStr ("\r");
                              return TRUE;

                         case WOTP_CLIPADDLF:
                              CheckRadioButton (hDlg, WOTP_CLIPADDCR, 
                                                WOTP_CLIPADDNONE,
                                                WOTP_CLIPADDLF);
                              SetClipAppendStr ("\n");
                              return TRUE;

                         case WOTP_DECREMENT:
                              DecrementCount (hDlg);
                              return TRUE;

			 case WOTP_AUTODECREMENT:
                              handle = GetDlgItem (hDlg, WOTP_AUTODECREMENT);
                              autodecrement = (WORD) 
                                     SendMessage (handle, BM_GETCHECK, 0, 0L);
                              return TRUE;
                 }
                 break;
    }
    return FALSE;
}

/*
 * if there is a valid count, seed set in the PARAMS edit control,
 * decrement the count and restuff the edit control with the new value.
 */

static void DecrementCount (HWND hwnd)
{    HANDLE handle;
     char params [128];
     unsigned int count;
     char seed [128];

     handle = GetDlgItem (hwnd, WOTP_PARAMS);
     GetWindowText (handle, (LPSTR) params, sizeof (params) - 1);
     if ((sscanf (params, "%u %s", &count, seed) != 2) || count <= 1)
     {   MessageBeep (0);
         return;
     }
     sprintf (params, "%u %s", count - 1, seed);
     SetWindowText (handle, (LPSTR) params);
}
    